-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
JavaScript/jQuery Scheduler - Current Time Indicator
The JavaScript Scheduler indicates the current time if you enable the showCurrentTimeIndicator property. Use the indicatorUpdateInterval property to specify how frequently the indicator should change its position.
You can also shade the timetable up to the current time. To enable this feature, set the shadeUntilCurrentTime property to true.
In this example, you can use the controls under the JavaScript Scheduler to change the above mentioned properties at runtime.
Backend API
$(() => {
const scheduler = $('#scheduler').dxScheduler({
dataSource: data,
views: ['week', 'timelineWeek'],
currentView: 'week',
showCurrentTimeIndicator: true,
indicatorUpdateInterval: 10000,
showAllDayPanel: false,
shadeUntilCurrentTime: true,
currentDate: new Date(),
editing: false,
height: 600,
resources: [{
fieldExpr: 'movieId',
dataSource: moviesData,
}],
appointmentTemplate(model) {
const movieInfo = getMovieById(model.appointmentData.movieId) || {};
return $(`${"<div class='movie'>"
+ "<img src='"}${movieInfo.image}' alt='${movieInfo.text} poster' />`
+ `<div class='movie-text'>${movieInfo.text}</div>`
+ '</div>');
},
onContentReady(e) {
e.component.scrollTo(new Date());
},
onAppointmentClick(e) {
e.cancel = true;
},
onAppointmentDblClick(e) {
e.cancel = true;
},
}).dxScheduler('instance');
$('#show-indicator').dxSwitch({
value: true,
onValueChanged(e) {
scheduler.option('showCurrentTimeIndicator', e.value);
},
});
$('#allow-shading').dxSwitch({
value: true,
onValueChanged(e) {
scheduler.option('shadeUntilCurrentTime', e.value);
},
});
$('#update-interval').dxNumberBox({
min: 1,
max: 1200,
value: 10,
step: 10,
showSpinButtons: true,
width: '100px',
format: '#0 s',
inputAttr: { 'aria-label': 'Interval' },
onValueChanged(e) {
scheduler.option('indicatorUpdateInterval', e.value * 1000);
},
});
function getMovieById(id) {
return DevExpress.data.query(moviesData)
.filter('id', id)
.toArray()[0];
}
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="js/dx.all.js?v=26.1.4"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="data.js"></script>
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="scheduler"></div>
<div class="options">
<div class="column">
<div class="option">
<div class="label">Current time indicator</div>
<div class="value">
<div id="show-indicator"></div>
</div>
</div>
<div class="option">
<div class="label">Shading until current time</div>
<div class="value">
<div id="allow-shading"></div>
</div>
</div>
</div>
<div class="column">
<div class="option">
<div class="label">Update position in</div>
<div class="value">
<div id="update-interval"></div>
</div>
</div>
</div>
</div>
</div>
</body>
</html>
.dx-scheduler-timeline .dx-scheduler-cell-sizes-horizontal {
width: 100px;
}
.dx-scheduler-appointment {
color: #000;
font-weight: 500;
background-color: #e4e4e4;
}
.dx-scheduler-appointment-recurrence .dx-scheduler-appointment-content {
padding: 5px 0 5px 7px;
}
.options {
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
display: flex;
align-items: flex-start;
}
.column {
width: 40%;
display: inline-block;
margin: 15px 3%;
text-align: left;
vertical-align: top;
}
.option {
padding: 5px 0;
display: flex;
align-items: center;
}
.label,
.value {
display: inline-block;
vertical-align: middle;
}
.label {
width: 180px;
}
.value {
width: 30%;
}
.movie img {
height: 70px;
}
.movie-text {
font-size: 90%;
white-space: normal;
}
#allow-shading,
#show-indicator {
height: 36px;
}
const today = new Date();
today.setHours(0, 0, 0, 0);
today.setDate(today.getDate() - today.getDay() + 3);
const data = [
{
movieId: 1,
startDate: new Date(today.getTime() - 113.5 * 3600000),
endDate: new Date(today.getTime() - 111.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 2,
startDate: new Date(today.getTime() - 110.5 * 3600000),
endDate: new Date(today.getTime() - 108.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 3,
startDate: new Date(today.getTime() - 106.5 * 3600000),
endDate: new Date(today.getTime() - 104.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 4,
startDate: new Date(today.getTime() - 104 * 3600000),
endDate: new Date(today.getTime() - 102 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 5,
startDate: new Date(today.getTime() - 101 * 3600000),
endDate: new Date(today.getTime() - 99 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
},
];
const moviesData = [{
id: 1,
text: 'His Girl Friday',
image: '../../../../images/movies/HisGirlFriday.jpg',
}, {
id: 2,
text: 'Royal Wedding',
image: '../../../../images/movies/RoyalWedding.jpg',
}, {
id: 3,
text: 'A Star Is Born',
image: '../../../../images/movies/AStarIsBorn.jpg',
}, {
id: 4,
text: 'The Screaming Skull',
image: '../../../../images/movies/ScreamingSkull.jpg',
}, {
id: 5,
text: "It's a Wonderful Life",
image: '../../../../images/movies/ItsAWonderfulLife.jpg',
}];

Backend API
<dx-scheduler
[dataSource]="appointmentsData"
[views]="['week', 'timelineWeek']"
currentView="week"
[currentDate]="currentDate"
[showCurrentTimeIndicator]="showCurrentTimeIndicator"
[shadeUntilCurrentTime]="shadeUntilCurrentTime"
[indicatorUpdateInterval]="indicatorUpdateInterval"
[showAllDayPanel]="false"
[height]="600"
[editing]="false"
appointmentTemplate="appointment-template"
(onContentReady)="onContentReady($event)"
(onAppointmentClick)="onAppointmentClick($event)"
(onAppointmentDblClick)="onAppointmentDblClick($event)"
>
<dxi-scheduler-resource fieldExpr="movieId" [dataSource]="moviesData">
</dxi-scheduler-resource>
<div *dxTemplate="let model of 'appointment-template'">
@if(getMovieById | apply : model.appointmentData.movieId; as movie) {
<div class="movie">
<img [src]="movie.image" alt="{{ movie.text }} poster" />
<div class="movie-text">{{ movie.text }}</div>
</div>
}
</div>
</dx-scheduler>
<div class="options">
<div class="column">
<div class="option">
<div class="label">Current time indicator</div>
<div class="value">
<dx-switch
[(value)]="showCurrentTimeIndicator"
id="show-indicator"
></dx-switch>
</div>
</div>
<div class="option">
<div class="label">Shading until current time</div>
<div class="value">
<dx-switch
[(value)]="shadeUntilCurrentTime"
id="allow-shading"
></dx-switch>
</div>
</div>
</div>
<div class="column">
<div class="option">
<div class="label">Update position in</div>
<div class="value">
<dx-number-box
id="update-interval"
(onValueChanged)="changeIndicatorUpdateInterval($event)"
[showSpinButtons]="true"
[min]="1"
[max]="1200"
[(value)]="intervalValue"
[step]="10"
[width]="100"
format="#0 s"
[inputAttr]="{ 'aria-label': 'Interval' }"
>
</dx-number-box>
</div>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { ViewChild, Component, enableProdMode, Pipe, PipeTransform, provideZoneChangeDetection } from '@angular/core';
import {
DxSchedulerModule,
DxSchedulerComponent,
DxSwitchModule,
DxNumberBoxModule,
} from 'devextreme-angular';
import { query as Query } from 'devextreme-angular/common/data';
import { DxSchedulerTypes } from 'devextreme-angular/ui/scheduler';
import { DxNumberBoxTypes } from 'devextreme-angular/ui/number-box';
import { Appointment, Service, MovieData } from './app.service';
@Pipe({ name: 'apply' })
export class ApplyPipe<TArgs, TReturn> implements PipeTransform {
transform(func: ((...args: TArgs[]) => TReturn), ...args: TArgs[]): TReturn { return func(...args); }
}
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
preserveWhitespaces: true,
imports: [
DxSchedulerModule,
DxSwitchModule,
DxNumberBoxModule,
ApplyPipe,
],
})
export class AppComponent {
@ViewChild(DxSchedulerComponent, { static: false }) scheduler: DxSchedulerComponent;
appointmentsData: Appointment[];
moviesData: MovieData[];
currentDate: Date = new Date();
showCurrentTimeIndicator = true;
shadeUntilCurrentTime = true;
intervalValue = 10;
indicatorUpdateInterval = 10000;
constructor(service: Service) {
this.appointmentsData = service.getAppointments();
this.moviesData = service.getMoviesData();
}
onContentReady = (e: DxSchedulerTypes.ContentReadyEvent) => {
e.component.scrollTo(new Date());
};
onAppointmentClick = (e: DxSchedulerTypes.AppointmentClickEvent) => {
e.cancel = true;
};
onAppointmentDblClick = (e: DxSchedulerTypes.AppointmentDblClickEvent) => {
e.cancel = true;
};
changeIndicatorUpdateInterval = (e: DxNumberBoxTypes.ValueChangedEvent) => {
this.indicatorUpdateInterval = e.value * 1000;
};
getMovieById = (id: string | number) => Query(this.moviesData).filter(['id', '=', id]).toArray()[0] as MovieData;
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep .dx-scheduler-timeline .dx-scheduler-cell-sizes-horizontal {
width: 100px;
}
::ng-deep .dx-scheduler-appointment {
color: #000;
font-weight: 500;
background-color: #e4e4e4;
}
::ng-deep .dx-scheduler-appointment-recurrence .dx-scheduler-appointment-content {
padding: 5px 0 5px 7px;
}
.options {
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
display: flex;
align-items: flex-start;
}
::ng-deep .column {
width: 40%;
display: inline-block;
margin: 15px 3%;
text-align: left;
vertical-align: top;
}
.option {
padding: 5px 0;
display: flex;
align-items: center;
}
::ng-deep .label,
.value {
display: inline-block;
vertical-align: middle;
}
.label {
width: 180px;
}
::ng-deep .value {
width: 30%;
}
::ng-deep .movie img {
height: 70px;
}
::ng-deep .movie-text {
font-size: 90%;
white-space: normal;
}
::ng-deep #allow-shading,
#show-indicator {
height: 36px;
}
import { Injectable } from '@angular/core';
export class Appointment {
startDate: Date;
endDate: Date;
movieId: number;
recurrenceRule?: string;
}
export class MovieData {
id: number;
text: string;
image: string;
}
const today = new Date();
today.setHours(0, 0, 0, 0);
today.setDate(today.getDate() - today.getDay() + 3);
const appointments: Appointment[] = [
{
movieId: 1,
startDate: new Date(today.getTime() - 113.5 * 3600000),
endDate: new Date(today.getTime() - 111.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 2,
startDate: new Date(today.getTime() - 110.5 * 3600000),
endDate: new Date(today.getTime() - 108.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 3,
startDate: new Date(today.getTime() - 106.5 * 3600000),
endDate: new Date(today.getTime() - 104.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 4,
startDate: new Date(today.getTime() - 104 * 3600000),
endDate: new Date(today.getTime() - 102 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 5,
startDate: new Date(today.getTime() - 101 * 3600000),
endDate: new Date(today.getTime() - 99 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
},
];
const moviesData: MovieData[] = [{
id: 1,
text: 'His Girl Friday',
image: '../../../../images/movies/HisGirlFriday.jpg',
}, {
id: 2,
text: 'Royal Wedding',
image: '../../../../images/movies/RoyalWedding.jpg',
}, {
id: 3,
text: 'A Star Is Born',
image: '../../../../images/movies/AStarIsBorn.jpg',
}, {
id: 4,
text: 'The Screaming Skull',
image: '../../../../images/movies/ScreamingSkull.jpg',
}, {
id: 5,
text: "It's a Wonderful Life",
image: '../../../../images/movies/ItsAWonderfulLife.jpg',
}];
@Injectable()
export class Service {
getAppointments(): Appointment[] {
return appointments;
}
getMoviesData(): MovieData[] {
return moviesData;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.16.2/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
},
"@angular/core": {
"version": "22.1.0"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "6.0.3"
},
"zone.js": {
"version": "0.16.2"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.16.2/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

Backend API
import React, { useCallback, useState } from 'react';
import Scheduler, { Resource } from 'devextreme-react/scheduler';
import { Switch } from 'devextreme-react/switch';
import { NumberBox } from 'devextreme-react/number-box';
import type { SchedulerTypes } from 'devextreme-react/scheduler';
import type { SwitchTypes } from 'devextreme-react/switch';
import type { NumberBoxTypes } from 'devextreme-react/number-box';
import { data, moviesData } from './data.ts';
import AppointmentTemplate from './AppointmentTemplate.tsx';
const currentDate = new Date();
const views: SchedulerTypes.ViewType[] = ['week', 'timelineWeek'];
const intervalLabel = { 'aria-label': 'Interval' };
const onContentReady = (e: SchedulerTypes.ContentReadyEvent) => {
e.component.scrollTo(new Date());
};
const onAppointmentClick = (e: SchedulerTypes.AppointmentClickEvent) => {
e.cancel = true;
};
const onAppointmentDblClick = (e: SchedulerTypes.AppointmentDblClickEvent) => {
e.cancel = true;
};
const App = () => {
const [showCurrentTimeIndicator, setShowCurrentTimeIndicator] = useState(true);
const [shadeUntilCurrentTime, setShadeUntilCurrentTime] = useState(true);
const [updateInterval, setUpdateInterval] = useState(10);
const onShowCurrentTimeIndicatorChanged = useCallback((e: SwitchTypes.ValueChangedEvent) => {
setShowCurrentTimeIndicator(e.value);
}, []);
const onShadeUntilCurrentTimeChanged = useCallback((e: SwitchTypes.ValueChangedEvent) => {
setShadeUntilCurrentTime(e.value);
}, []);
const onUpdateIntervalChanged = useCallback((e: NumberBoxTypes.ValueChangedEvent) => {
setUpdateInterval(e.value);
}, []);
return (
<>
<Scheduler
dataSource={data}
views={views}
defaultCurrentView="week"
showCurrentTimeIndicator={showCurrentTimeIndicator}
indicatorUpdateInterval={updateInterval * 1000}
showAllDayPanel={false}
shadeUntilCurrentTime={shadeUntilCurrentTime}
defaultCurrentDate={currentDate}
editing={false}
height={600}
appointmentComponent={AppointmentTemplate}
onContentReady={onContentReady}
onAppointmentClick={onAppointmentClick}
onAppointmentDblClick={onAppointmentDblClick}
>
<Resource
dataSource={moviesData}
fieldExpr="movieId"
/>
</Scheduler>
<div className="options">
<div className="column">
<div className="option">
<div className="label">Current time indicator </div>
{' '}
<div className="value">
<Switch
id="show-indicator"
value={showCurrentTimeIndicator}
onValueChanged={onShowCurrentTimeIndicatorChanged}
/>
</div>
</div>
<div className="option">
<div className="label">Shading until current time </div>
{' '}
<div className="value">
<Switch
id="allow-shading"
value={shadeUntilCurrentTime}
onValueChanged={onShadeUntilCurrentTimeChanged}
/>
</div>
</div>
</div>
{' '}
<div className="column">
<div className="option">
<div className="label">Update position in </div>
{' '}
<div className="value">
<NumberBox
min={1}
max={1200}
value={updateInterval}
step={10}
showSpinButtons={true}
width={100}
format="#0 s"
inputAttr={intervalLabel}
onValueChanged={onUpdateIntervalChanged}
/>
</div>
</div>
</div>
</div>
</>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import Scheduler, { Resource } from 'devextreme-react/scheduler';
import { Switch } from 'devextreme-react/switch';
import { NumberBox } from 'devextreme-react/number-box';
import { data, moviesData } from './data.js';
import AppointmentTemplate from './AppointmentTemplate.js';
const currentDate = new Date();
const views = ['week', 'timelineWeek'];
const intervalLabel = { 'aria-label': 'Interval' };
const onContentReady = (e) => {
e.component.scrollTo(new Date());
};
const onAppointmentClick = (e) => {
e.cancel = true;
};
const onAppointmentDblClick = (e) => {
e.cancel = true;
};
const App = () => {
const [showCurrentTimeIndicator, setShowCurrentTimeIndicator] = useState(true);
const [shadeUntilCurrentTime, setShadeUntilCurrentTime] = useState(true);
const [updateInterval, setUpdateInterval] = useState(10);
const onShowCurrentTimeIndicatorChanged = useCallback((e) => {
setShowCurrentTimeIndicator(e.value);
}, []);
const onShadeUntilCurrentTimeChanged = useCallback((e) => {
setShadeUntilCurrentTime(e.value);
}, []);
const onUpdateIntervalChanged = useCallback((e) => {
setUpdateInterval(e.value);
}, []);
return (
<>
<Scheduler
dataSource={data}
views={views}
defaultCurrentView="week"
showCurrentTimeIndicator={showCurrentTimeIndicator}
indicatorUpdateInterval={updateInterval * 1000}
showAllDayPanel={false}
shadeUntilCurrentTime={shadeUntilCurrentTime}
defaultCurrentDate={currentDate}
editing={false}
height={600}
appointmentComponent={AppointmentTemplate}
onContentReady={onContentReady}
onAppointmentClick={onAppointmentClick}
onAppointmentDblClick={onAppointmentDblClick}
>
<Resource
dataSource={moviesData}
fieldExpr="movieId"
/>
</Scheduler>
<div className="options">
<div className="column">
<div className="option">
<div className="label">Current time indicator </div>{' '}
<div className="value">
<Switch
id="show-indicator"
value={showCurrentTimeIndicator}
onValueChanged={onShowCurrentTimeIndicatorChanged}
/>
</div>
</div>
<div className="option">
<div className="label">Shading until current time </div>{' '}
<div className="value">
<Switch
id="allow-shading"
value={shadeUntilCurrentTime}
onValueChanged={onShadeUntilCurrentTimeChanged}
/>
</div>
</div>
</div>{' '}
<div className="column">
<div className="option">
<div className="label">Update position in </div>{' '}
<div className="value">
<NumberBox
min={1}
max={1200}
value={updateInterval}
step={10}
showSpinButtons={true}
width={100}
format="#0 s"
inputAttr={intervalLabel}
onValueChanged={onUpdateIntervalChanged}
/>
</div>
</div>
</div>
</div>
</>
);
};
export default App;
import React from 'react';
import { query as Query } from 'devextreme-react/common/data';
import type { Appointment } from './data.ts';
import { moviesData } from './data.ts';
type AppointmentTemplateProps = {
data: { appointmentData: Appointment; };
};
const getMovieById = (id: number) => Query(moviesData).filter(['id', id]).toArray()[0];
const AppointmentTemplate = (props: AppointmentTemplateProps) => {
const { appointmentData } = props.data;
const movieInfo = getMovieById(appointmentData.movieId) || {};
return (
<div className="movie">
<img src={movieInfo.image} alt={`${movieInfo.text} poster`} />
<div className="movie-text">{movieInfo.text}</div>
</div>
);
};
export default AppointmentTemplate;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
import type { SchedulerTypes } from 'devextreme-react/scheduler';
export type Appointment = SchedulerTypes.Appointment & { movieId: number };
type Resource = {
id: number;
text: string;
image: string;
};
export const today = new Date();
today.setHours(0, 0, 0, 0);
today.setDate(today.getDate() - today.getDay() + 3);
export const data: Appointment[] = [
{
movieId: 1,
startDate: new Date(today.getTime() - 113.5 * 3600000),
endDate: new Date(today.getTime() - 111.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 2,
startDate: new Date(today.getTime() - 110.5 * 3600000),
endDate: new Date(today.getTime() - 108.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 3,
startDate: new Date(today.getTime() - 106.5 * 3600000),
endDate: new Date(today.getTime() - 104.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 4,
startDate: new Date(today.getTime() - 104 * 3600000),
endDate: new Date(today.getTime() - 102 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 5,
startDate: new Date(today.getTime() - 101 * 3600000),
endDate: new Date(today.getTime() - 99 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
},
];
export const moviesData: Resource[] = [{
id: 1,
text: 'His Girl Friday',
image: '../../../../images/movies/HisGirlFriday.jpg',
}, {
id: 2,
text: 'Royal Wedding',
image: '../../../../images/movies/RoyalWedding.jpg',
}, {
id: 3,
text: 'A Star Is Born',
image: '../../../../images/movies/AStarIsBorn.jpg',
}, {
id: 4,
text: 'The Screaming Skull',
image: '../../../../images/movies/ScreamingSkull.jpg',
}, {
id: 5,
text: 'It\'s a Wonderful Life',
image: '../../../../images/movies/ItsAWonderfulLife.jpg',
}];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import { query as Query } from 'devextreme-react/common/data';
import { moviesData } from './data.js';
const getMovieById = (id) => Query(moviesData).filter(['id', id]).toArray()[0];
const AppointmentTemplate = (props) => {
const { appointmentData } = props.data;
const movieInfo = getMovieById(appointmentData.movieId) || {};
return (
<div className="movie">
<img
src={movieInfo.image}
alt={`${movieInfo.text} poster`}
/>
<div className="movie-text">{movieInfo.text}</div>
</div>
);
};
export default AppointmentTemplate;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const today = new Date();
today.setHours(0, 0, 0, 0);
today.setDate(today.getDate() - today.getDay() + 3);
export const data = [
{
movieId: 1,
startDate: new Date(today.getTime() - 113.5 * 3600000),
endDate: new Date(today.getTime() - 111.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
},
{
movieId: 2,
startDate: new Date(today.getTime() - 110.5 * 3600000),
endDate: new Date(today.getTime() - 108.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
},
{
movieId: 3,
startDate: new Date(today.getTime() - 106.5 * 3600000),
endDate: new Date(today.getTime() - 104.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
},
{
movieId: 4,
startDate: new Date(today.getTime() - 104 * 3600000),
endDate: new Date(today.getTime() - 102 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
},
{
movieId: 5,
startDate: new Date(today.getTime() - 101 * 3600000),
endDate: new Date(today.getTime() - 99 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
},
];
export const moviesData = [
{
id: 1,
text: 'His Girl Friday',
image: '../../../../images/movies/HisGirlFriday.jpg',
},
{
id: 2,
text: 'Royal Wedding',
image: '../../../../images/movies/RoyalWedding.jpg',
},
{
id: 3,
text: 'A Star Is Born',
image: '../../../../images/movies/AStarIsBorn.jpg',
},
{
id: 4,
text: 'The Screaming Skull',
image: '../../../../images/movies/ScreamingSkull.jpg',
},
{
id: 5,
text: "It's a Wonderful Life",
image: '../../../../images/movies/ItsAWonderfulLife.jpg',
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
.dx-scheduler-timeline .dx-scheduler-cell-sizes-horizontal {
width: 100px;
}
.dx-scheduler-appointment {
color: #000;
font-weight: 500;
background-color: #e4e4e4;
}
.dx-scheduler-appointment-recurrence .dx-scheduler-appointment-content {
padding: 5px 0 5px 7px;
}
.options {
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
display: flex;
align-items: flex-start;
}
.column {
width: 40%;
display: inline-block;
margin: 15px 3%;
text-align: left;
vertical-align: top;
}
.option {
padding: 5px 0;
display: flex;
align-items: center;
}
.label,
.value {
display: inline-block;
vertical-align: middle;
}
.label {
width: 180px;
}
.value {
width: 30%;
}
.movie img {
height: 70px;
}
.movie-text {
font-size: 90%;
white-space: normal;
}
#allow-shading,
#show-indicator {
height: 36px;
}

Backend API
<template>
<div>
<DxScheduler
:data-source="dataSource"
:current-date="currentDate"
:views="views"
:show-current-time-indicator="showCurrentTimeIndicator"
:indicator-update-interval="updateInterval * 1000"
:shade-until-current-time="shadeUntilCurrentTime"
@content-ready="onContentReady"
@appointment-click="onAppointmentClick"
@appointment-dbl-click="onAppointmentDblClick"
:editing="false"
:show-all-day-panel="false"
appointment-template="AppointmentTemplateSlot"
height="600"
current-view="week"
>
<DxResource
:data-source="moviesData"
field-expr="movieId"
/>
<template #AppointmentTemplateSlot="{ data }">
<AppointmentTemplate :appointment-model="data"/>
</template>
</DxScheduler>
<div class="options">
<div class="column">
<div class="option">
<div class="label">Current time indicator</div>
<div class="value">
<DxSwitch
id="show-indicator"
v-model:value="showCurrentTimeIndicator"
/>
</div>
</div>
<div class="option">
<div class="label">Shading until current time</div>
<div class="value">
<DxSwitch
id="allow-shading"
v-model:value="shadeUntilCurrentTime"
/>
</div>
</div>
</div>
<div class="column">
<div class="option">
<div class="label">Update position in</div>
<div class="value">
<DxNumberBox
v-model:value="updateInterval"
:format="'#0 s'"
:min="1"
:max="1200"
:step="10"
:show-spin-buttons="true"
width="100"
:input-attr="{ 'aria-label': 'Interval' }"
/>
</div>
</div>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxScheduler, { DxResource, type DxSchedulerTypes } from 'devextreme-vue/scheduler';
import { DxSwitch } from 'devextreme-vue/switch';
import { DxNumberBox } from 'devextreme-vue/number-box';
import AppointmentTemplate from './AppointmentTemplate.vue';
import { data, moviesData } from './data.ts';
const views = ['week', 'timelineWeek'];
const currentDate = new Date();
const showCurrentTimeIndicator = ref(true);
const shadeUntilCurrentTime = ref(true);
const updateInterval = ref(10);
const dataSource = data;
function onContentReady(e: DxSchedulerTypes.ContentReadyEvent) {
e.component.scrollTo(new Date());
}
function onAppointmentClick(e: DxSchedulerTypes.AppointmentClickEvent) {
e.cancel = true;
}
function onAppointmentDblClick(e: DxSchedulerTypes.AppointmentDblClickEvent) {
e.cancel = true;
}
</script>
<style scoped>
.dx-scheduler-timeline .dx-scheduler-cell-sizes-horizontal {
width: 100px;
}
.dx-scheduler-appointment {
color: #000;
font-weight: 500;
background-color: #e4e4e4;
}
.dx-scheduler-appointment-recurrence .dx-scheduler-appointment-content {
padding: 5px 0 5px 7px;
}
.options {
background-color: rgba(191, 191, 191, 0.15);
margin-top: 20px;
display: flex;
align-items: flex-start;
}
.column {
width: 40%;
display: inline-block;
margin: 15px 3%;
text-align: left;
vertical-align: top;
}
.option {
padding: 5px 0;
display: flex;
align-items: center;
}
.label,
.value {
display: inline-block;
vertical-align: middle;
}
.label {
width: 180px;
}
.value {
width: 30%;
}
.movie img {
height: 70px;
}
.movie-text {
font-size: 90%;
white-space: normal;
}
#allow-shading,
#show-indicator {
height: 36px;
}
</style>
<template>
<div class="movie">
<img
:src="movieInfo.image"
:alt="`${movieInfo.text} poster`"
>
<div class="movie-text">{{ movieInfo.text }}</div>
</div>
</template>
<script setup lang="ts">
import { query as Query } from 'devextreme-vue/common/data';
import type { DxSchedulerTypes } from 'devextreme-vue/scheduler';
import { moviesData } from './data.ts';
const props = defineProps<{
appointmentModel: DxSchedulerTypes.AppointmentTemplateData
}>();
const getMovieInfo = function (data: DxSchedulerTypes.Appointment) {
return Query(moviesData)
.filter(['id', data.movieId])
.toArray()[0] || {};
};
const movieInfo = getMovieInfo(props.appointmentModel.appointmentData);
</script>
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'typescript': {
'exports': 'ts',
},
'vue': {
format: 'global',
exports: 'Vue',
esModule: true,
},
'vuex': {
format: 'global',
exports: 'Vuex',
esModule: true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.40/dist/vue.global.js',
'@vue/shared': 'npm:@vue/shared@3.4.26/dist/shared.cjs.prod.js',
'dx-systemjs-vue-browser': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'vue-loader': 'loaders:demo-vue-loader.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
export const today = new Date();
today.setHours(0, 0, 0, 0);
today.setDate(today.getDate() - today.getDay() + 3);
export const data = [
{
movieId: 1,
startDate: new Date(today.getTime() - 113.5 * 3600000),
endDate: new Date(today.getTime() - 111.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 2,
startDate: new Date(today.getTime() - 110.5 * 3600000),
endDate: new Date(today.getTime() - 108.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 3,
startDate: new Date(today.getTime() - 106.5 * 3600000),
endDate: new Date(today.getTime() - 104.5 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 4,
startDate: new Date(today.getTime() - 104 * 3600000),
endDate: new Date(today.getTime() - 102 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
}, {
movieId: 5,
startDate: new Date(today.getTime() - 101 * 3600000),
endDate: new Date(today.getTime() - 99 * 3600000),
recurrenceRule: 'FREQ=HOURLY;INTERVAL=15;COUNT=15',
},
];
export const moviesData = [{
id: 1,
text: 'His Girl Friday',
image: '../../../../images/movies/HisGirlFriday.jpg',
}, {
id: 2,
text: 'Royal Wedding',
image: '../../../../images/movies/RoyalWedding.jpg',
}, {
id: 3,
text: 'A Star Is Born',
image: '../../../../images/movies/AStarIsBorn.jpg',
}, {
id: 4,
text: 'The Screaming Skull',
image: '../../../../images/movies/ScreamingSkull.jpg',
}, {
id: 5,
text: 'It\'s a Wonderful Life',
image: '../../../../images/movies/ItsAWonderfulLife.jpg',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>